"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactNative = require("react-native");
var _react = _interopRequireWildcard(require("react"));
var _reactNativeKeyboardAwareScrollView = require("react-native-keyboard-aware-scroll-view");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const {
  height
} = _reactNative.Dimensions.get('window');
// @ts-ignore
const KeyboardAwareScrollView = /*#__PURE__*/_react.default.forwardRef((props, ref) => {
  const scroll = (0, _react.useRef)(null);
  const scrolAnimation = (0, _react.useRef)(new _reactNative.Animated.Value(1)).current;
  const [ScrolledSize, setScrolledSize] = (0, _react.useState)(1);
  const [ScrolledContainerSize, setScrolledContainerSize] = (0, _react.useState)(height);
  const animation = (0, _react.useCallback)((val, ch) => {
    // Animated.spring(scrolAnimation, {
    //   toValue: ScrolledContainerSize * (val / ch),
    //   useNativeDriver: true,
    //   bounciness: 8,
    //   velocity:Platform.OS ==="ios"&& velocity || undefined,
    //   delay: 0,
    // }).start();
    _reactNative.Animated.timing(scrolAnimation, {
      toValue: ScrolledContainerSize * (val / ch),
      useNativeDriver: true,
      duration: 0,
      delay: 0,
      easing: _reactNative.Easing.ease
    }).start();
  }, [scrolAnimation, ScrolledContainerSize]);
  const _Scrolled = (0, _react.useCallback)(event => {
    setScrolledSize(event.nativeEvent.contentSize.height);
    animation(event.nativeEvent.contentOffset.y, event.nativeEvent.contentSize.height);
    props.onScroll && props?.onScroll(event);
  }, [animation, ScrolledSize]);
  const _ContentHeight = (0, _react.useCallback)(event => {
    setScrolledContainerSize(event.nativeEvent.layout.height);
    props.onLayout && props?.onLayout(event);
  }, [ScrolledContainerSize]);
  (0, _react.useEffect)(() => {
    const t = setTimeout(() => {
      if (ref)
        // @ts-ignore
        ref.current?.scrollToPosition(0, 1, false);else scroll.current?.scrollToPosition(0, 1, false);
    }, 10);
    return () => clearTimeout(t);
  }, []);
  const indicator = ScrolledContainerSize / (ScrolledSize / ScrolledContainerSize);
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, _extends({}, props.parentViewProps || {}, {
    style: [styles.container, !props.flexDisabled && styles.flexEnabled || {}, props.parentViewProps?.style || {}]
  }), /*#__PURE__*/_react.default.createElement(_reactNativeKeyboardAwareScrollView.KeyboardAwareScrollView, _extends({
    scrollEventThrottle: 70,
    showsVerticalScrollIndicator: false
  }, props, {
    ref: ref || scroll
    // @ts-ignore
    ,
    onScroll: _Scrolled,
    onLayout: _ContentHeight
  }), props.children), props.showAlways && ScrolledContainerSize < ScrolledSize && /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, {
    style: styles.indicatorView(indicator, scrolAnimation, props.indicatorColor, props.indicatorWidth, props.indicatorborder)
  }));
});
var _default = exports.default = KeyboardAwareScrollView;
KeyboardAwareScrollView.defaultProps = {
  indicatorborder: 20,
  indicatorColor: '#303030',
  indicatorWidth: 4,
  showAlways: true
};
const styles = _reactNative.StyleSheet.create({
  indicatorView: (height, scrolAnimation, color, width, borderRadius) => ({
    position: 'absolute',
    top: 0,
    right: 0,
    width: width,
    backgroundColor: color,
    height,
    borderRadius,
    transform: [{
      translateY: scrolAnimation
    }]
  }),
  container: {
    position: 'relative',
    width: '100%'
  },
  flexEnabled: {
    flex: 1
  }
});
//# sourceMappingURL=KeyboardAwareScrollView.js.map