function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import { Dimensions, ScrollView as NativeScroll, StyleSheet, View, Animated, Easing } from 'react-native';
import React, { useCallback, useRef, useState, useEffect } from 'react';
const {
  height
} = Dimensions.get('window');
// @ts-ignore
const ScrollView = /*#__PURE__*/React.forwardRef((props, ref) => {
  const scroll = useRef(null);
  const scrolAnimation = useRef(new Animated.Value(1)).current;
  const [ScrolledSize, setScrolledSize] = useState(1);
  const [ScrolledContainerSize, setScrolledContainerSize] = useState(height);
  const animation = useCallback((val, ch) => {
    // Animated.spring(scrolAnimation, {
    //   toValue: ScrolledContainerSize * (val / ch),
    //   useNativeDriver: true,
    //   bounciness: 8,
    //   velocity:Platform.OS ==="ios"&& velocity || undefined,

    //   delay: 0,
    // }).start();
    Animated.timing(scrolAnimation, {
      toValue: ScrolledContainerSize * (val / ch),
      useNativeDriver: true,
      duration: 0,
      delay: 0,
      easing: Easing.ease
    }).start();
  }, [scrolAnimation, ScrolledContainerSize]);
  const _Scrolled = useCallback(event => {
    setScrolledSize(event.nativeEvent.contentSize.height);
    animation(event.nativeEvent.contentOffset.y, event.nativeEvent.contentSize.height);
    props.onScroll && props?.onScroll(event);
  }, [animation, ScrolledSize]);
  const _ContentHeight = useCallback(event => {
    setScrolledContainerSize(event.nativeEvent.layout.height);
    props.onLayout && props?.onLayout(event);
  }, [ScrolledContainerSize]);
  useEffect(() => {
    const t = setTimeout(() => {
      if (ref)
        // @ts-ignore
        ref.current?.scrollTo({
          y: 1
        });else scroll.current?.scrollTo({
        y: 1
      });
    }, 10);
    return () => clearTimeout(t);
  }, []);
  const indicator = ScrolledContainerSize / (ScrolledSize / ScrolledContainerSize);
  return /*#__PURE__*/React.createElement(View, _extends({}, props.parentViewProps || {}, {
    style: [styles.container, !props.flexDisabled && styles.flexEnabled || {}, props.parentViewProps?.style || {}]
  }), /*#__PURE__*/React.createElement(NativeScroll, _extends({
    scrollEventThrottle: 70,
    showsVerticalScrollIndicator: false
  }, props, {
    ref: ref || scroll
    // @ts-ignore
    ,
    onScroll: _Scrolled,
    onLayout: _ContentHeight
  }), props.children), props.showAlways && ScrolledContainerSize < ScrolledSize && /*#__PURE__*/React.createElement(Animated.View, {
    style: styles.indicatorView(indicator, scrolAnimation, props.indicatorColor, props.indicatorWidth, props.indicatorborder)
  }));
});
export default ScrollView;
ScrollView.defaultProps = {
  indicatorborder: 20,
  indicatorColor: '#303030',
  indicatorWidth: 4,
  showAlways: true
};
const styles = StyleSheet.create({
  indicatorView: (height, scrolAnimation, color, width, borderRadius) => ({
    position: 'absolute',
    top: 0,
    right: 0,
    width: width,
    backgroundColor: color,
    height,
    borderRadius,
    transform: [{
      translateY: scrolAnimation
    }]
  }),
  container: {
    position: 'relative',
    width: '100%'
  },
  flexEnabled: {
    flex: 1
  }
});
//# sourceMappingURL=ScrollView.js.map